fifa/bet/urls.py
from django.urls import path, re_path
from bet import views

urlpatterns = [
    path('',
         views.LoginView.as_view(),
         name='login'),
    path('logout/',
         views.logout_view,
         name='logout'),

    path('home',
         views.HomeView.as_view(),
         name='home'),
    path('matches',
         views.MatchesView.as_view(),
         name='matches'),
    path('predictions',
         views.BetsView.as_view(),
         name='my_bets'),

    path('leaderboard',
         views.LeaderboardView.as_view(),
         name='leaderboard'),
    path('leaderboard-departments',
         views.DepartmentLeaderboardView.as_view(),
         name='department-leaderboard'),
    path('leaderboard-departments/<str:d>',
         views.UserDepartmentLeaderboardView.as_view(),
         name='user-department-leaderboard'),
    path('leaderboard-locations',
         views.LocationLeaderboardView.as_view(),
         name='location-leaderboard'),

    path('results',
         views.MatchResultsView.as_view(),
         name='match_results'),
    path('prediction/<int:pk>/',
         views.BetCreate.as_view(),
         name='add_bet'),
    path('predictions/<int:pk>/',
         views.AllBetsView.as_view(),
         name='all_bets'),
    path('championship-prediction/',
         views.SuperBetCreate.as_view(),
         name='add_super_bet'),
]

fifa/fifa/urls.py
from django.conf import settings
from django.conf.urls import url
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('', include('bet.urls')),
    path('admin/', admin.site.urls),
    url(r'^tz_detect/', include('tz_detect.urls')),
]

if settings.DEBUG:
    import debug_toolbar
    urlpatterns = [
        url(r'^__debug__/', include(debug_toolbar.urls)),
    ] + urlpatterns

fifa/bet/models.py
import datetime

import pytz
from django.db import models
from django.db.models import Model
from django.contrib.auth.models import User


class Country(Model):
    name = models.CharField(max_length=20)
    img_src = models.CharField(max_length=200, blank=True, null=True)

    class Meta:
        verbose_name_plural = 'Countries'

    def __str__(self):
        return self.name


class Match(Model):
    STAGES = (
        ('GROUP', 'GROUP'),
        ('ROUND OF 16', 'ROUND OF 16'),
        ('QUARTER-FINALS', 'QUARTER-FINALS'),
        ('SEMI-FINALS', 'SEMI-FINALS'),
        ('THIRD PLACE', 'THIRD PLACE'),
        ('FINALS', 'FINALS'),
    )
    home = models.ForeignKey(Country, related_name='home_matches', on_delete=models.CASCADE)
    away = models.ForeignKey(Country, related_name='away_matches', on_delete=models.CASCADE)
    time = models.DateTimeField()
    stage = models.CharField(max_length=45, choices=STAGES)
    home_goals = models.PositiveIntegerField(blank=True, null=True)
    away_goals = models.PositiveIntegerField(blank=True, null=True)
    home_penalties = models.PositiveIntegerField(blank=True, null=True)
    away_penalties = models.PositiveIntegerField(blank=True, null=True)
    fifa_url = models.CharField(max_length=200, blank=True, null=True)

    def __str__(self):
        return "{} vs {}".format(self.home.name, self.away.name)

    def is_frozen(self):
        return self.time < datetime.datetime.now(pytz.utc)

    def has_bet_on(self, user):
        return self.bets.filter(user=user).exists()

    class Meta:
        verbose_name_plural = 'Matches'


class Bet(Model):
    user = models.ForeignKey(User, related_name='bets', on_delete=models.CASCADE)
    match = models.ForeignKey(Match, related_name='bets', on_delete=models.CASCADE)
    home_goals = models.PositiveIntegerField(default=0)
    away_goals = models.PositiveIntegerField(default=0)

    def __str__(self):
        return "{} - {} : {} - {}".format(self.match, self.home_goals, self.away_goals, self.user)

    @property
    def is_exact(self):
        if self.match.home_goals is None or self.match.away_goals is None:
            return False
        return self.match.home_goals == self.home_goals and self.match.away_goals == self.away_goals

    @property
    def is_correct(self):
        if self.match.home_goals is None or self.match.away_goals is None:
            return False
        sign = lambda x: x and (1, -1)[x < 0]
        return (
            sign(self.match.home_goals - self.match.away_goals)
            ==
            sign(self.home_goals - self.away_goals)
        )

    def get_score(self):
        if self.is_exact:
            return 3
        if self.is_correct:
            return 2
        return 0


class SuperBet(Model):
    user = models.OneToOneField(User, related_name='super_bet', on_delete=models.CASCADE)
    country = models.ForeignKey(Country, related_name='super_bets', on_delete=models.CASCADE)
    last_updated = models.DateTimeField(auto_now=True)

    @staticmethod
    def get_match():
        match = Match.objects.filter(stage='FINALS')
        if not match.exists():
            return None
        return match.first()

    @staticmethod
    def can_be_saved():
        match = Match.objects.filter(stage='FINALS')
        if not match.exists():
            return True
        match = match.first()
        return not match.is_frozen()

    def won(self, match):
        if not match:
            return
        if match.home_goals is None or match.away_goals is None:
            return
        if match.home_goals > match.away_goals:
            return match.home == self.country
        elif match.away_goals > match.home_goals:
            return match.away == self.country
        elif match.home_penalties > match.away_penalties:
            return match.home == self.country
        return match.away == self.country

    def get_score(self, match):
        if self.won(match) is not None and self.won(match):
            return 2 + round(0.33 * (match.time - self.last_updated).days)
        return 0

    def __str__(self):
        return str(self.country)


class UserInfo(models.Model):
    user = models.OneToOneField("auth.User", related_name='info', on_delete=models.CASCADE)

    department_name = models.CharField(max_length=512)
    location_name = models.CharField(max_length=512)

    def __str__(self):
        return self.user.username + " - " + self.department_name

fifa/bet/views.py
from datetime import datetime
from urllib.parse import unquote

from django.conf import settings
from django.http import Http404
from django.shortcuts import redirect
from django.urls import reverse
from django.views.generic import CreateView
from django.views.generic import TemplateView
from django.contrib.auth import authenticate, logout, login
from django.http import HttpResponseRedirect
from django.contrib.auth.models import User

from bet.models import Match, Bet, SuperBet, Country, UserInfo


class LoginRequiredMixin(object):
    def dispatch(self, request, *args, **kwargs):
        if request.user.is_authenticated:
            return super().dispatch(request, *args, **kwargs)
        return redirect('login')


class LoginView(TemplateView):
    template_name = 'login.html'

    def dispatch(self, request, *args, **kwargs):
        if self.request.user.is_authenticated:
            return redirect('home')
        return super().dispatch(request, *args, **kwargs)

    def get(self, request, *args, **kwargs):
        if 'ticket' not in request.GET:
            return super().get(request, *args, **kwargs)
        ticket = request.GET['ticket']
        user = authenticate(request, ticket=ticket)
        if user:
            login(request, user)
            return redirect('home')
        return redirect('login')

    def post(self, request, *args, **kwargs):
        return redirect(settings.CAS_LOGIN_URL.format(settings.CURRENT_SERVICE))


def logout_view(request):
    logout(request)
    return redirect('login')


class HomeView(LoginRequiredMixin, TemplateView):
    template_name = 'home.html'

    def get_context_data(self, *args, **kwargs):
        context = super().get_context_data(*args, **kwargs)
        matches = Match.objects.filter(time__date=datetime.now().date()).order_by('time').all()
        if matches.exists():
            context['matches'] = matches
        else:
            next_match = Match.objects.filter(time__gte=datetime.now()).order_by('time').first()
            if next_match:
                context['next_match'] = next_match
        return context


class MatchesView(LoginRequiredMixin, TemplateView):
    template_name = 'matches/matches.html'

    def get_context_data(self, *args, **kwargs):
        context = super().get_context_data(*args, **kwargs)
        context['matches'] = Match.objects.filter(time__gt=datetime.now()).order_by('time').prefetch_related('away', 'home').all()
        context['bets'] = self.request.user.bets.values_list('match__pk', flat=True)

        return context


class BetsView(LoginRequiredMixin, TemplateView):
    template_name = 'bets/my_bets.html'

    def get_context_data(self, *args, **kwargs):
        context = super().get_context_data(*args, **kwargs)
        bets = Bet.objects.filter(user=self.request.user).prefetch_related('match', 'match__away', 'match__home').order_by('-match__time')

        completed = []
        in_progress = []

        for bet in bets:
            if bet.match.is_frozen():
                completed.append(bet)
            else:
                in_progress.insert(0, bet)

        context['completed_bets'] = completed
        context['in_progress_bets'] = in_progress
        try:
            user = self.request.user
            context['super_bet'] = user.super_bet
        except SuperBet.DoesNotExist:
            pass
        context['can_super_bet'] = SuperBet.can_be_saved()
        return context


class LeaderboardView(LoginRequiredMixin, TemplateView):
    template_name = 'leaderboard.html'

    def get_context_data(self, *args, **kwargs):
        context = super().get_context_data(*args, **kwargs)
        users = User.objects.prefetch_related('info').all()
        result = {}
        for user in users:
            full_name = user.get_full_name()
            result.update({
                full_name: {
                    'score': 0,
                    'super_won': 0,
                    'won': 0,
                    'placed': 0,
                    'department': user.info.department_name
                }
            })
        bets = Bet.objects.prefetch_related('match', 'user').all()
        for bet in bets:
            user = bet.user.get_full_name()
            result[user]['score'] += bet.get_score()
            result[user]['placed'] += 1
            if bet.is_exact:
                result[user]['super_won'] += 1
            elif bet.is_correct:
                result[user]['won'] += 1
        super_bets = SuperBet.objects.prefetch_related('user', 'country').all()
        match = SuperBet.get_match()
        for super_bet in super_bets:
            user = super_bet.user.get_full_name()
            result[user]['score'] += super_bet.get_score(match)
            result[user]['super_bet'] = super_bet

        scores = [result[key]['score'] for key in result.keys()]
        scores = list(set(scores))
        scores.sort(reverse=True)
        for user in result.keys():
            result[user]['position'] = scores.index(result[user]['score']) + 1
        context['result'] = result
        return context


class UserDepartmentLeaderboardView(LoginRequiredMixin, TemplateView):
    template_name = 'leaderboard.html'

    def get_context_data(self, *args, **kwargs):
        context = super().get_context_data(*args, **kwargs)
        users = User.objects.filter(info__department_name=unquote(self.kwargs['d'])).all()
        result = {}
        for user in users:
            full_name = user.first_name + ' ' + user.last_name
            result.update({
                full_name: {
                    'score': 0,
                    'super_won': 0,
                    'won': 0,
                    'placed': 0
                }
            })
        bets = Bet.objects.filter(user__in=users).prefetch_related('match', 'user', 'user__info').all()
        for bet in bets:
            user = bet.user.get_full_name()
            result[user]['score'] += bet.get_score()
            result[user]['placed'] += 1
            if bet.is_exact:
                result[user]['super_won'] += 1
            elif bet.is_correct:
                result[user]['won'] += 1
        super_bets = SuperBet.objects.filter(user__in=users).prefetch_related('user', 'country').all()
        match = SuperBet.get_match()
        for super_bet in super_bets:
            user = super_bet.user.get_full_name()
            result[user]['score'] += super_bet.get_score(match)
            result[user]['super_bet'] = super_bet

        scores = [result[key]['score'] for key in result.keys()]
        scores = list(set(scores))
        scores.sort(reverse=True)
        for user in result.keys():
            result[user]['position'] = scores.index(result[user]['score']) + 1
        context['result'] = result
        return context


class DepartmentLeaderboardView(LoginRequiredMixin, TemplateView):
    template_name = 'leaderboard.html'

    def get_context_data(self, *args, **kwargs):
        context = super().get_context_data(*args, **kwargs)
        infos = UserInfo.objects.all()
        result = {}
        for info in infos:
            department = info.department_name
            if department not in result:
                result.update({
                    department: {
                        'score': 0,
                        'super_won': 0,
                        'won': 0,
                        'members': 1
                    }
                })
            else:
                result[department]['members'] += 1
        bets = Bet.objects.filter(user__info__isnull=False).prefetch_related('match', 'user')\
            .select_related('user__info').all()
        for bet in bets:
            department = bet.user.info.department_name
            result[department]['score'] += bet.get_score()
            if bet.is_exact:
                result[department]['super_won'] += 1
            elif bet.is_correct:
                result[department]['won'] += 1
        super_bets = SuperBet.objects.filter(user__info__isnull=False).prefetch_related('user', 'country')\
            .select_related('user__info').all()
        match = SuperBet.get_match()
        for super_bet in super_bets:
            department = super_bet.user.info.department_name
            result[department]['score'] += super_bet.get_score(match)

        scores = [result[key]['score'] for key in result.keys()]
        scores = list(set(scores))
        scores.sort(reverse=True)
        for department in result.keys():
            result[department]['position'] = scores.index(result[department]['score']) + 1
            result[department]['placed'] = int(result[department]['score'] / result[department]['members'])
        context['result'] = result
        return context


class LocationLeaderboardView(LoginRequiredMixin, TemplateView):
    template_name = 'leaderboard.html'

    def get_context_data(self, *args, **kwargs):
        context = super().get_context_data(*args, **kwargs)
        infos = UserInfo.objects.all()
        result = {}
        for info in infos:
            location = info.location_name
            result.update({
                location: {
                    'score': 0,
                    'super_won': 0,
                    'won': 0,
                    'placed': 0
                }
            })
        bets = Bet.objects.filter(user__info__isnull=False).prefetch_related('match', 'user', 'user__info').all()
        for bet in bets:
            location = bet.user.info.location_name
            result[location]['score'] += bet.get_score()
            result[location]['placed'] += 1
            if bet.is_exact:
                result[location]['super_won'] += 1
            elif bet.is_correct:
                result[location]['won'] += 1
        super_bets = SuperBet.objects.filter(user__info__isnull=False).prefetch_related('user', 'country') \
            .select_related('user__info').all()
        match = SuperBet.get_match()
        for super_bet in super_bets:

fifa/bet/templates/bets/add_bet.html
{% extends '_layout.html' %}
{% load staticfiles %}
{% load bulma_tags %}
{% block content %}
    <div class="container has-text-centered is-fullwidth">
        <div class="column is-offset-3 is-6">
            <div>
                <p class="title">
                    <img src="{{ match.home.img_src }}"/>
                    {{ match.home.name }}
                    &nbsp; vs &nbsp;
                    <img src="{{ match.away.img_src }}"/>
                    {{ match.away.name }}
                </p>
            </div>
            <br>
            <div>
                <div>
                    <form method="post">
                        {% csrf_token %}
                        <div class="field">
                            <label class="label">Home goals</label>
                            <div class="control ">
                                <input type="number" name="home_goals" class="input has-text-centered"
                                       id="id_home_goals" min="0" required
                                        {% if bet %} value={{ bet.home_goals }} {% endif %}
                                {% if match.is_frozen %} readonly {% endif %}>
                            </div>
                        </div>

                        <div class="field">
                            <label class="label">Away goals</label>
                            <div class="control ">
                                <input type="number" name="away_goals" class="input has-text-centered"
                                       id="id_away_goals" min="0" required
                                        {% if bet %} value={{ bet.away_goals }} {% endif %}
                                {% if match.is_frozen %} readonly {% endif %}>
                            </div>
                        </div>
                        {% if match.is_frozen %}
                            <p>This match has already started</p>
                        {% else %}
                            <input type="submit" class="button is-link" value="Make prediction"/>
                        {% endif %}
                    </form>
                </div>
            </div>
            <br>
            <div class="subtitle">You will earn 3 points if your prediction is exact and 2 points if you only guess the
                match outcome.
            </div>
            <div class="has-text-link">
                Score is recorded only for the first 120 minutes.
            </div>
            <div class="is-size-7 has-text-weight-light">
                Penalties are not taken into consideration for correct/exact predictions.
                (ex: If A-B match ends 2-2 and A wins after penalties, a correct outcome would be equal).
            </div>
        </div>
    </div>
{% endblock %}

fifa/bet/templates/bets/add_super_bet.html
{% extends '_layout.html' %}
{% load staticfiles %}
{% load bulma_tags %}
{% block content %}
    <div class="container has-text-centered is-fullwidth">
        <div class="column is-offset-3 is-6">
            <div>
                <p class="title">
                    2018 World Champion
                </p>
                {% if super_bet %}
                    <p class="subtitle">
                        Placed on {{ super_bet.last_updated }}
                    </p>
                {% endif %}
            </div>
            <br>
            <div>
                <div>
                    <form method="post">
                        {% csrf_token %}
                        <div class="field">
                            <div class="control">
                                <div class="select is-fullwidth">
                                    <select name="country" id="id_country">
                                        {% for country in countries %}
                                            <option value="{{ country.pk }}"
                                                    {% if super_bet and super_bet.country == country %}
                                                    selected {% endif %}>
                                                {{ country }}
                                            </option>
                                        {% endfor %}
                                    </select>
                                </div>
                            </div>
                        </div>
                        {% if match.is_frozen %}
                            <p>This match has already started</p>
                        {% else %}
                            <input type="submit" class="button is-link" value="Make prediction"/>
                        {% endif %}
                    </form>
                </div>
            </div>
            <br>
            <div class="subtitle">You will earn 2 points + 1 point for each 3 days until the final if your prediction is
                correct.
            </div>
        </div>
    </div>
{% endblock %}

fifa/bet/templates/bets/all_bets.html
{% extends '_layout.html' %}
{% load staticfiles %}
{% block content %}

    <div class="title has-text-centered">
        <img src="{{ match.home.img_src }}"/>
        {{ match.home.name }}
        &nbsp; vs &nbsp;
        <img src="{{ match.away.img_src }}"/>
        {{ match.away.name }}
    </div>
    {% if match.home_goals is not None and match.away_goals is not None %}
        <div class="title has-text-centered">
            {{ match.home_goals }}
            &nbsp; : &nbsp;
            {{ match.away_goals }}
        </div>
    {% endif %}
    <br>
    <br>
    {% for bet in bets %}
        {% if forloop.counter0|divisibleby:3 %}
            <div class="tile is-ancestor">
        {% endif %}
    <div class="tile is-parent is-4">
        <div class="tile is-child is-info has-text-centered">
            <div class="card">
                <div class="card-content">
                    <p class="title {% if bet.is_exact %} has-text-success {% elif bet.is_correct %} has-text-link {% endif %}">
                        {{ bet.home_goals }} : {{ bet.away_goals }}
                    </p>
                    <p class="subtitle">
                        {{ bet.user.get_full_name }}
                    </p>
                </div>
            </div>
        </div>
    </div>
    {% if forloop.counter|divisibleby:3 or forloop.last %}
        </div>
    {% endif %}
    {% endfor %}
{% endblock %}

fifa/bet/templates/bets/my_bets.html
{% extends '_layout.html' %}
{% load staticfiles %}
{% block content %}
    <div class="tile is-ancestor">
    <div class="tile is-parent">
        <div class="tile is-child has-text-centered">
            <div class="card">
                <div class="card-content">
                    <p class="title">
                        2018 World Champion
                    </p>
                    <p class="subtitle">
                        {% if super_bet %}
                            <img src="{{ super_bet.country.img_src }}"/> {{ super_bet.country }}
                            <br>
                            Placed on {{ super_bet.last_updated }}
                        {% else %}
                            Unknown
                        {% endif %}
                    </p>
                </div>

                <footer class="card-footer">
                    <p class="card-footer-item">
                        {% if can_super_bet %}
                            <span>
                                <a href="{% url 'add_super_bet' %}">Change prediction</a>
                            </span>
                        {% else %}
                            <span>Can't be changed.</span>
                        {% endif %}
                    </p>
                </footer>
            </div>
            <div class="tile is-child"></div>
        </div>
    </div>
    </div>
    <h2 class="subtitle is-uppercase">Future predictions</h2>
    {% if in_progress_bets %}
        {% include 'matches/bet_trio.html' with bets=in_progress_bets %}
    {% else %}
        <p>You have no future match predictions.</p>
    {% endif %}
    <hr>
    <h2 class="subtitle is-uppercase">Completed predictions</h2>
    {% if completed_bets %}
        {% include 'matches/bet_trio.html' with bets=completed_bets %}
    {% else %}
        <p>You have no completed match predictions.</p>
    {% endif %}
{% endblock %}